#% Programa para generar los parámetros de una elipse
#% a , b, Xc, Yc, alfa,
#% a partir de la matriz que representa una cónica (elipse)
#% Fraga 28/06/2001
#% Ahora en python
# Fraga 19.07.2021 
import sys
import math
import numpy as np

# La elipse está dada en una matriz en binario
# Se da el nombre del archivo en la línea de comandos

n = len( sys.argv )
if n != 2 :
	print("Args: archivo_elipse.bin")
	sys.exit(1)

E = np.fromfile( sys.argv[1] )

E = E.reshape( (3,3) )

a = E[0,0];
b = E[0,1];
c = E[1,1];
d = E[0,2];
e = E[1,2]; 
g = E[2,2];

angulo =  math.atan (  2.0 * b / (a - c) )*90.0/math.pi;

aux3 = b*b - a*c;

xc = (c*d - b*e)/aux3;
yc = (a*e - b*d)/aux3;


aux1 = math.fabs( 2.0 * ( a*e*e+ c*d*d + g*b*b - 2.0*b*d*e - a*c*g ) );
aux2 = math.fabs( (b*b-a*c) * ( (c-a)*math.sqrt(1.0 + ( (4.0*b*b)/((a-c)*(a-c)) ) ) - (c+a) ) );
aux3 = math.fabs( (b*b-a*c) * ( (a-c)*math.sqrt(1.0 + ( (4.0*b*b)/((a-c)*(a-c)) ) ) - (c+a) ) );

eje_a = math.sqrt ( aux1 / aux2);
eje_b = math.sqrt ( aux1 / aux3);

if eje_a < eje_b : 
	aux1 = eje_a;
	eje_a = eje_b;
	eje_b = aux1;
	if angulo < 0.0 :
         angulo += 90.0;
	else :
		angulo -= 90.0;

print("a = ", eje_a);
print("b = ", eje_b);
print("Xc = ", xc );
print("Yc = ", yc );
print("ang = ", angulo);

